package database

import (
	"git.linuxforward.com/byom/byom-onboard/internal/common/models"
)

func (d *Database) RegisterUser(user *models.User) error {
	// Save registration details to database
	err := d.db.Create(user).Error
	if err != nil {
		return err
	}

	return nil
}

func (d *Database) ChangeSubscriptionStatus(email string) error {
	// Change the status of the user to active
	user, err := d.getUserByEmail(email)
	if err != nil {
		return err
	}

	user.Status = true

	err = d.updateUser(user)
	if err != nil {
		return err
	}

	return nil
}

func (d *Database) getUserByEmail(email string) (*models.User, error) {
	var user *models.User
	err := d.db.Where("email = ?", email).First(&user).Error
	if err != nil {
		return nil, err
	}

	return user, nil
}

func (d *Database) updateUser(user *models.User) error {
	err := d.db.Save(user).Error
	if err != nil {
		return err
	}

	return nil
}
